/** SALSA/World Wide Computer Project
 *  ObjectHandler recieves incoming objects
 *  and determines if they are actors or messages.
 *  upon recieving actors, it will start them up.
 *  messages get sent to the appropriate actor.
 *
 *  author Travis Desell
 */
package io.core.messaging;

import java.net.*;
import java.io.*;
import java.util.Hashtable;
import java.util.Vector;
import salsa.language.*;

public class IOHandler extends wwc.messaging.BasicHandler {
	private IOTheater theater;
	private int maxTimeToLive;	//should be a command line argument, or specified by the theater

	public IOHandler(IOTheater _theater) {
		super(_theater);
		theater = _theater;
	}

	public void process(Object recieved, Socket in) {
		if (recieved instanceof ActorState) {
			ActorState incomingActor = (ActorState) recieved;
			processActor(incomingActor, in);
		} else if (recieved instanceof Message) {  // just serializing data
	        	Message m = (Message) recieved;
			processMessage(m);
      		} else if (recieved instanceof TheaterLocator) {
			theater.getNeighbors().add(recieved);
		}
   	}
}
