package io.core.server;

import java.io.*;
import java.net.*;
import java.util.Vector;
import io.core.messaging.IOTheater;

public class ServerHandler extends Thread {

	private IOTheater theater;
	private Vector serverList;

	private int maxPeerConnections;

	public ServerHandler(IOTheater _theater, Vector _serverList, int _maxPeerConnections) {
		theater = _theater;
		serverList = _serverList;
		maxPeerConnections = _maxPeerConnections;
	}

	public void run () {
		for (int i = 0; i < serverList.size(); i++) {
        	        try {
				URL serverLocation = new URL((String)serverList.get(i));

	                        //Connect to the given Server;
				Socket serverConnection = new Socket(serverLocation.getHost(), serverLocation.getPort());
				ObjectOutputStream out = new ObjectOutputStream(new BufferedOutputStream(serverConnection.getOutputStream()));
				
				//First we write the maximum number of Peer's we want to connect to
				//then we write our current location,  and close the connection
				out.writeObject(new Integer(maxPeerConnections / serverList.size()));
	                        out.writeObject(theater.getLocation());
	                        out.flush();
	                        out.close();
	                        serverConnection.close();  
                        
                	} catch (UnknownHostException e) {
                	        System.err.println("Error sending information to server: "+serverList.get(i)+":"+e);
                	} catch (IOException e) {
                	        System.err.println("Error sending information to server: "+serverList.get(i)+":"+e);
          		}
		}
	}

}
