package salsa.naming;

/**
	This interface contains methods for manipulating a naming service.
	
	@author stepha
*/
public interface NamingService {

	/**
		This method returns the location associated with the specified UAN 
		or null if the UAN does not exist.
	*/
	public UAL resolve( UAN name );
	
	/**
		This method adds the specified name location mapping to the name service.
	*/
	public void add( UAN name, UAL location );
	
	/**
		This method updates the specified name location mapping in the name service.
	*/
	public void update( UAN name, UAL location );
	
	/**
		This method deletes the specified name location mapping from the name service.
	*/
	public void delete( UAN name, UAL location );
}
