/** SALSA/World Wide Computer Project
 *  ObjectHandler recieves incoming objects
 *  and determines if they are actors or messages.
 *  upon recieving actors, it will start them up.
 *  messages get sent to the appropriate actor.
 *
 *  author Travis Desell
 */
package wwc.messaging;

import java.net.*;
import java.io.*;
import salsa.language.ServiceFactory;

public class ObjectHandler extends Thread {
	private Socket incoming;

	public ObjectHandler(Socket _incoming) {
		incoming = _incoming;

		setName( "Object Handler Thread" );
	}

	public void run() {
		// Read in the object.
		Object received = null;
		ObjectInputStream stream = null;
		BasicHandler handler = new BasicHandler( ServiceFactory.getTheater() );

		try {
			stream = new ObjectInputStream( incoming.getInputStream() );
		} catch (IOException e) {
			System.err.println( "IOException occured reading object " + e.getMessage() );
			return;
		}

//the following is not working correctly - to get persistentMessenging to work
// - travis
//		while (incoming.isConnected()) {
			try {
				received = stream.readObject();
			} catch (ClassNotFoundException e) {
				System.err.println( "Could not load class for " + received.getClass().getName() );
				System.err.println( "  Is it in the theater CLASSPATH" );
				System.err.println( e.getMessage() );
//				break;
				return;
			} catch (IOException e) {
				System.err.println( "IOException occured reading object " + e.getMessage() );
//				break;
				return;
			}
			handler.process(received, incoming);
//		}

		// Close the connection.
		try {
			incoming.close();
		} catch (IOException e) {
			System.err.println( "IOException occured closing connection" + e.getMessage() );

			return;
		}
	}
}
